/* XulGrid.java */
package org.jxul.framework;

import java.io.*;
import java.util.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;

import org.w3c.dom.*;

import org.jxul.util.*;

/**
 * A XUL Titled Box. 
 */
public class XulGrid extends XulBox
{
    public static final boolean debug;
    
    static
    {
        // this variation works in both applets and applications
        boolean temp = false;
        try
        {
            String sdebug = System.getProperty("debug");
            if (sdebug != null && sdebug.equalsIgnoreCase("true"))
                temp = true;
            else
                temp = false;
        } catch (Exception e)
          { }
        debug = temp;
    }
    
    private Element gridElement;
    Hashtable peerMap;
    
    public XulGrid(Element gridElement, Hashtable peerMap) throws XulFormatException
    {
        super(gridElement, peerMap);
        this.gridElement = gridElement;

    } // end of XulGrid Constructor

    public void processChildren() throws XulFormatException
    {
        // calculate the # of rows and columns
        int columns = 0;
        int rows = 0;
        Node rowsChild = null;
        NodeList rowChildren = null;
        
        /* children should be a set of widget elements 
            or more boxes. */
        NodeList children = boxElement.getChildNodes();
            
        // iterate through each child, if a menu - create it
        int childCount = children.getLength();
        for (int i=0; i < childCount; i++)
        {
            Node child = children.item(i);
            if (debug)
                 System.out.println("Child[" + i + "]" +
                 child.getNodeName() + "-" + child.getNodeValue());
 
            if (child.getNodeName().equals(XulSyntax.ELEMENT_COLUMNS))
            {
                if (child.hasChildNodes())
                {
                    NodeList columnChildren = child.getChildNodes();
                    columns = columnChildren.getLength();
                }
            }
            else if (child.getNodeName().equals(XulSyntax.ELEMENT_ROWS))
            {
                rowsChild = child;
                if (child.hasChildNodes())
                {
                    rowChildren = child.getChildNodes();
                    rows = rowChildren.getLength();
                }                
            }
        }
        
        // set the layout manager
        setLayout(new GridLayout(rows, columns));        
        
        // process all rows
        if (rowChildren != null)
        {
            for (int i=0; i < rows; i++)
            {
                if (debug) System.out.println("processing row: " + i);
                Node rowChild = rowChildren.item(i);
                if (debug) System.out.println("element: " + rowChild.getNodeName());
                if (rowChild.hasChildNodes())
                {
                    super.processChildren((Element)rowChild);
                }
            }
        }
    }
        
    /** for unit testing. */
    public static void main(String args[])
    {
        try
        {
            
        } catch (Throwable t)
          {
            t.printStackTrace();
          }
    }
}
