/* XulMenuItem.java */
package org.jxul.framework;

import java.io.*;
import javax.swing.*;

import org.w3c.dom.*;

import org.jxul.util.*;

/**
 * A XUL MenuItem.
 */
public class XulMenuItem extends JMenuItem
{
    public static final boolean debug;
    
    static
    {
        // this variation works in both applets and applications
        boolean temp = false;
        try
        {
            String sdebug = System.getProperty("debug");
            if (sdebug != null && sdebug.equalsIgnoreCase("true"))
                temp = true;
            else
                temp = false;
        } catch (Exception e)
          { }
        debug = temp;
    }
    
    private Element menuItemElement;
    // attributes
    private String type;
    private String name;
    private String label;
    private String key;
    private String disabled;
    private String id;
    private String _class;
    private String acceltext;
    private String accesskey;
    private String oncommand;
    private String observes;
    private String checked;
    private String data;
    
    private boolean groupItem;
    
    public boolean isGroupItem() { return groupItem; }

    public String getType() { return type; }    
    
    public String getName() { return name; }
        
    public XulMenuItem(Element menuItemElement)
    {
        this.menuItemElement = menuItemElement;
        
        // what type of menu item???
        Attr typeAttr = menuItemElement.getAttributeNode(XulSyntax.MENUITEM_ATTR_TYPE);
        if (typeAttr != null)
        {
            type = typeAttr.getNodeValue();    
            
            // if this has a type - it is a "group" item
            groupItem = true;
        }
        
        Attr nameAttr = menuItemElement.getAttributeNode(XulSyntax.MENUITEM_ATTR_NAME);
        if (nameAttr != null)
            name = nameAttr.getNodeValue();    
        
        // TBD: complete the processing of all the attributes
        
        Attr labelAttr = menuItemElement.getAttributeNode(XulSyntax.MENUITEM_ATTR_LABEL);
        if (labelAttr != null)
        {
            label = labelAttr.getNodeValue();
            if (label != null && !StringUtil.isBlank(label))
                this.setText(label);
        }
                    
        Attr keyAttr = menuItemElement.getAttributeNode(XulSyntax.MENUITEM_ATTR_KEY);
        if (keyAttr != null)
            key = keyAttr.getNodeValue();
            
        Attr disabledAttr = menuItemElement.getAttributeNode(XulSyntax.MENUITEM_ATTR_DISABLED);
        if (disabledAttr != null)
        {
            disabled = disabledAttr.getNodeValue();
            if (disabled.equals(XulSyntax.MENUITEM_ATTR_DISABLED_TRUE))
                this.setEnabled(false);
            else    
                this.setEnabled(true);
        }
        Attr idAttr = menuItemElement.getAttributeNode(XulSyntax.MENUITEM_ATTR_ID);
        Attr _classAttr = menuItemElement.getAttributeNode(XulSyntax.MENUITEM_ATTR_CLASS);
        Attr acceltextAttr = menuItemElement.getAttributeNode(XulSyntax.MENUITEM_ATTR_ACCELTEXT);
        Attr accesskeyAttr = menuItemElement.getAttributeNode(XulSyntax.MENUITEM_ATTR_ACCESSKEY);
        Attr oncommandAttr = menuItemElement.getAttributeNode(XulSyntax.MENUITEM_ATTR_ONCOMMAND);                
        Attr observes= menuItemElement.getAttributeNode(XulSyntax.MENUITEM_ATTR_OBSERVES);
        Attr checked = menuItemElement.getAttributeNode(XulSyntax.MENUITEM_ATTR_CHECKED);
        Attr data = menuItemElement.getAttributeNode(XulSyntax.MENUITEM_ATTR_DATA);
    }
    
    /** for unit testing. */
    public static void main(String args[])
    {
        try
        {
            
        } catch (Throwable t)
          {
            t.printStackTrace();
          }
    }
}
