// XulJsElement.java 
package org.jxul.js;

import org.jxul.framework.*;

import org.w3c.dom.*;
import org.mozilla.javascript.*;
import java.awt.*;

import javax.swing.*;

public class XulJsElement extends ScriptableObject
{
    public static final boolean debug;
    
    static
    {
        // this variation works in both applets and applications
        boolean temp = false;
        try
        {
            String sdebug = System.getProperty("debug");
            if (sdebug != null && sdebug.equalsIgnoreCase("true"))
                temp = true;
            else
                temp = false;
        } catch (Exception e)
          { }
        debug = temp;
    }
    
    Element elem;
    JComponent peer;                    
        
    // create a javascript function to mirror - setAttribute
    public static void jsFunction_setAttribute(Context cx, Scriptable thisObj,
                                               Object[] args, Function funObj)
    {
        
        XulJsElement el = (XulJsElement)thisObj;
        JComponent peer = el.peer;
        
        if (args.length == 2)
        {
        	String att = args[0].toString();
        
   			//info for positioning
   			Point current = peer.getLocation();
   			int currx = current.x;
   			int curry = current.y;
   			
 
        	if (att.equals("top"))
        	{
        		  Number top = (Number)args[1];
        		  int newy = top.intValue();
        		  peer.setLocation(new Point(currx, newy));
        		 
        	}
        	else if (att.equals("left"))
        	{
        		  Number left = (Number)args[1];
        		  int newx = left.intValue();
        		  peer.setLocation(new Point(newx, curry));
        	 
        	}
        	else if (att.equals("hidden"))
        	{
        		Boolean val = (Boolean)args[1];
        	    peer.setVisible(!val.booleanValue());	
        	    
            }	
        	else
        	{
        	   		System.out.println("TBD - Attribute " + att + " ignored..");
        	}
        }
        else 
        {
           System.out.println("There were not 2 arguments, and will therefore be ignored.");
        }
         
        /* 
            NOTE - 
            
            If we redesign every XUL component to extend another class,
            i.e. XULComponent, or to implement a iXULComponent interface,
            we could have the peer be the interface or the superclass that
            can have setAttribute() and getAttribute() methods. 
            
            This is how we can handle all of the JavaScript in each XUL
            component.
            
            But for now, we will only handle certain attributes that JComponent
            knows about.
  
            -KTS 7/7/01
         */   
         
        
    }

    public static void jsFunction_removeAttribute(Context cx, Scriptable thisObj,
                                               Object[] args, Function funObj)
    {
        
        System.out.println("function: removeAttribute");
        for (int i=0; i < args.length; i++)
            System.out.println(args[i]);

        // Does this affect the peer??
        
    
    }

    // Method jsConstructor defines the JavaScript constructor 
    /** Note: cannot have more than one constructor??? 
    public void jsConstructor() 
    { 
        System.out.println("No-Arg Constructor for XulJsElement");    
    }
    **/
    public static Scriptable jsConstructor(Context cx, Object[] args,
                                           Function ctorObj, 
                                           boolean inNewExpr)
    {
        if (debug) System.out.println("Arg Constructor for XulJsElement");    
        XulJsElement xe = new XulJsElement();
        
        // should have 2 arguments
        if (args.length == 2)
        {
            xe.elem = (Element)args[0];
            xe.peer = (JComponent)args[1];
        }
        
        return xe;
    }
    
    public XulJsElement() { } 
    
    public XulJsElement(Element elem, JComponent peer) 
    {
        this.elem = elem;
        this.peer = peer;
    }
        
    public String getClassName()
    {
        return "XulJsElement"; 
    }
}
