// XulJsWindow.java 
package org.jxul.js;

import org.jxul.util.*;
import org.jxul.framework.*;

import org.mozilla.javascript.*;
import org.w3c.dom.*;

import java.awt.*;
import javax.swing.*;
import java.util.*;

public class XulJsWindow extends ScriptableObject
{
    public static final boolean debug;
    
    static
    {
        // this variation works in both applets and applications
        boolean temp = false;
        try
        {
            String sdebug = System.getProperty("debug");
            if (sdebug != null && sdebug.equalsIgnoreCase("true"))
                temp = true;
            else
                temp = false;
        } catch (Exception e)
          { }
        debug = temp;
    }    
        
    static XulDom xdom;
    
    // properties see JavaScript Definitive Guide    
    
    // create a javascript function to mirror - setInterval
    public static void jsFunction_setInterval(Context cx, Scriptable thisObj,
                                            Object[] args, Function funObj)
    {
         
        try
        {
  
          Function fun = (Function)args[0];  
          int sleeptime = ((Number)args[1]).intValue(); 
          while (true)
          {
          	
            fun.call(cx, thisObj,thisObj, args);
            Thread.sleep(sleeptime);
          }							
        }
        catch (Exception e)
        {
        	e.printStackTrace();
    	}
    }

    public static void jsFunction_print(Context cx, Scriptable thisObj,
                                            Object[] args, Function funObj)      
    {
	JOptionPane.showMessageDialog(null,"Print not implemented.");
    }
    // Method jsConstructor defines the JavaScript constructor 
    public void jsConstructor() 
    { 
        System.out.println("JS constructor for XulJsWindow");    
    }
    
    public XulJsWindow() 
    {
        // when created by the javascript engine
        // will need to go out and "attach" to the
        // XUL DOM
    }
    
    public void setXulDom(XulDom env)
    {
        xdom = env;    
    }
    
    public String getClassName()
    {
        return "window"; 
    }
}
