/* XulUtil.java */
package org.jxul.util;

import java.util.*;

public class XulUtil
{
    public static final boolean debug;
    
    static
    {
        // this variation works in both applets and applications
        boolean temp = false;
        try
        {
            String sdebug = System.getProperty("debug");
            if (sdebug != null && sdebug.equalsIgnoreCase("true"))
                temp = true;
            else
                temp = false;
        } catch (Exception e)
          { }
        debug = temp;
    }
    
    /**
     * translateURL - translate chrome:// & the like
     *                to absolute pathnames
     * @param href - the url string
     * 
     * Let's make "chromebase" a property. If a chrome
     * URL comes about and there is no such property,
     * this function should return null. 
     * ks 1/5
     */    
    public static String translateURL(String href)
    {
	String xulprotocol = "chrome:";
	String chromebase = System.getProperty("chromebase");

        if (href != null && href.indexOf(xulprotocol)==0
              && href.length() > xulprotocol.length())
        {
            if (chromebase != null)
               href = chromebase + href.indexOf(":") + 1;
            else
               href = null;
        } 		
 
        return (href);
    }
           
} 
